{% for account in k8s_service_accounts %}
---
apiVersion: v1
kind: ServiceAccount
metadata:
  name: {{ account.name }}
{% if account.namespace is defined %}
  namespace: {{ account.namespace }}
{% endif %}

{% endfor %}

{% for role in k8s_roles %}
---
apiVersion: rbac.authorization.k8s.io/v1
kind: Role
metadata:
{% if role.namespace is defined %}
  namespace: {{ role.namespace }}
{% endif %}
  name: {{ role.name }}
rules:
{% for rule in role.rules %}
  - apiGroups: {{ rule.apiGroups }}
    resources: {{ rule.resources }}
    verbs: {{ rule.verbs }}
{% endfor %}
{% endfor %}

{% for role in k8s_clusterroles %}
---
apiVersion: rbac.authorization.k8s.io/v1
kind: ClusterRole
metadata:
{% if role.namespace is defined %}
  namespace: {{ role.namespace }}
{% endif %}
  name: {{ role.name }}
rules:
{% for rule in role.rules %}
{% if rule.nonResourceURLs is defined %}
  - nonResourceURLs: {{ rule.nonResourceURLs }}
{% else %}
  - apiGroups: {{ rule.apiGroups }}
    resources: {{ rule.resources }}
{% endif %}
    verbs: {{ rule.verbs }}
{% endfor %}
{% endfor %}

{% for binding in k8s_role_bindings %}
---
apiVersion: rbac.authorization.k8s.io/v1
kind: {{ binding.kind }}
metadata:
  name: {{ binding.name }}
{% if binding.namespace is defined %}
  namespace: {{ binding.namespace }}
{% endif %}

subjects:
{% for subject in binding.subjects %}
- kind: {{ subject.kind }}
  name: {{ subject.name }}
{% if subject.namespace is defined %}
  namespace: {{ subject.namespace }}
{% endif %}
{% endfor %}

roleRef:
  kind: {{ binding.roleRef.kind }}
  name: {{ binding.roleRef.name }}
  apiGroup: {{ binding.roleRef.apiGroup }}

{% endfor %}

